#ifndef BOOST_STATECHART_EVENT_HPP_INCLUDED
#define BOOST_STATECHART_EVENT_HPP_INCLUDED
//////////////////////////////////////////////////////////////////////////////
// (c) Copyright Andreas Huber Doenni 2002-2005
// Distributed under the Boost Software License, Version 1.0. (See accompany-
// ing file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//////////////////////////////////////////////////////////////////////////////



#include <boost/statechart/event_base.hpp>
#include <boost/statechart/detail/rtti_policy.hpp>
#include <boost/cast.hpp> // boost::polymorphic_downcast



namespace boost
{
namespace statechart
{



//////////////////////////////////////////////////////////////////////////////
template< class MostDerived >
class event : public detail::rtti_policy::rtti_derived_type<
  MostDerived, event_base >
{
  // Compiler-generated copy constructor and copy assignment operator are fine
  protected:
    //////////////////////////////////////////////////////////////////////////
    event() {}
    virtual ~event() {}

  private:
    //////////////////////////////////////////////////////////////////////////
    virtual intrusive_ptr< const event_base > clone() const
    {
      return intrusive_ptr< const event_base >( new MostDerived(
        *polymorphic_downcast< const MostDerived * >( this ) ) );
    }
};



} // namespace statechart
} // namespace boost



#endif
